unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, sSkinProvider, sSkinManager, StdCtrls, Buttons, sBitBtn,
  ExtCtrls, sPanel, ComCtrls, ShellCtrls, ShellAPI, Registry, WavedImage;

type
  TForm1 = class(TForm)
    sSkinManager1: TsSkinManager;
    sSkinProvider1: TsSkinProvider;
    sPanel1: TsPanel;
    sBitBtn1: TsBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    sPanel2: TsPanel;
    Label3: TLabel;
    sBitBtn2: TsBitBtn;
    Label4: TLabel;
    OpenDialog1: TOpenDialog;
    Label5: TLabel;
    sPanel3: TsPanel;
    Label6: TLabel;
    Label7: TLabel;
    Image3: TWavedImage;
    Image1: TWavedImage;
    Image2: TWavedImage;
    sPanel4: TsPanel;
    sBitBtn3: TsBitBtn;
    sBitBtn4: TsBitBtn;
    sBitBtn5: TsBitBtn;
    sBitBtn6: TsBitBtn;
    Timer1: TTimer;
    procedure sBitBtn2Click(Sender: TObject);
    procedure sBitBtn1Click(Sender: TObject);
    procedure Label5DblClick(Sender: TObject);
    procedure sBitBtn3Click(Sender: TObject);
    procedure sBitBtn6Click(Sender: TObject);
    procedure sBitBtn4Click(Sender: TObject);
    procedure sBitBtn5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    UninstallOK:string;
    InstallOK:string;
    InstallKO:string;
    RegCommand:string;
  end;

var
  Form1: TForm1;
  CurDir:string;

implementation

uses UnitsDialog, Unit3, Unit2;

{$R *.dfm}
{$R Zipres.res}


procedure Bui_ExecuteWait(Programme:string; Params:string; Showornot:integer);
var
  ShExecInfo : TShellExecuteInfo;
begin
  FillChar(ShExecInfo, SizeOf(ShExecInfo), 0);
  with ShExecInfo do
  begin
    cbSize := SizeOf(ShExecInfo);
    fMask  := SEE_MASK_NOCLOSEPROCESS;
    lpFile := PChar(Programme);
    lpVerb := 'open';
    lpParameters := PChar(Params);
    nShow  := Showornot;
  end;
  if ShellExecuteEx(@ShExecInfo) then
    WaitForSingleObject(ShExecInfo.hProcess, INFINITE);
end;


function Bui_TempRep():string;
var
  TempDir : array[0..MAX_PATH] of Char;
  nSize : DWord;
begin
  nSize:=SizeOf(TempDir);
  GetTempPath(nSize, @TempDir);
  result:=TempDir;
  if (result[length(result)]<>'\') then result:=result+'\';
end;




procedure decompresserFichier(Nom: string; Fichier: string);
var
  Zip:TResourceStream;
begin
  Zip:=TResourceStream.Create(Hinstance,Nom,'EXEFILE');
  Zip.SavetoFile(Fichier);
  Zip.Free;
end;



procedure SupprimerFichier(Fichier:string);
begin
  if FileExists(Fichier) then
  try
    DeleteFile(Fichier);
  except
  end;
end;



procedure extraireFichiers(Repertoire: string);
begin
  ChDir(PChar(Repertoire));
  decompresserFichier('bios_bin', 'bios.bin');
  decompresserFichier('libusb0_dll', 'libusb0.dll');
  decompresserFichier('fmod_dll', 'fmod.dll');
  decompresserFichier('kqemu_inf', 'kqemu.inf');
  decompresserFichier('kqemu_sys', 'kqemu.sys');
  decompresserFichier('qemu_exe', 'qemu.exe');
  decompresserFichier('SDL_dll', 'SDL.dll');
  decompresserFichier('vgabios_bin', 'vgabios.bin');
  decompresserFichier('vgabios_cirrus_bin', 'vgabios-cirrus.bin');
  if not DirectoryExists('keymaps') then
    MkDir('keymaps');
  ChDir('keymaps');
  decompresserFichier('fr', 'fr');
  decompresserFichier('modifiers', 'modifiers');
  decompresserFichier('common','common');
  decompresserFichier('ar','ar');
  decompresserFichier('da','da');
  decompresserFichier('de','de');
  decompresserFichier('dech','de-ch');
  decompresserFichier('engb','en-gb');
  decompresserFichier('enus','en-us');
  decompresserFichier('es','es');
  decompresserFichier('et','et');
  decompresserFichier('fi','fi');
  decompresserFichier('fo','fo');
  decompresserFichier('frbe','fr-be');
  decompresserFichier('frca','fr-ca');
  decompresserFichier('frch','fr-ch');
  decompresserFichier('hr','hr');
  decompresserFichier('hu','hu');
  decompresserFichier('is','is');
  decompresserFichier('it','it');
  decompresserFichier('ja','ja');
  decompresserFichier('lt','lt');
  decompresserFichier('lv','lv');
  decompresserFichier('mk','mk');
  decompresserFichier('nl','nl');
  decompresserFichier('nlbe','nl-be');
  decompresserFichier('no','no');
  decompresserFichier('pl','pl');
  decompresserFichier('pt','pt');
  decompresserFichier('ptbr','pt-br');
  decompresserFichier('ru','ru');
  decompresserFichier('sl','sl');
  decompresserFichier('sv','sv');
  decompresserFichier('th','th');
  decompresserFichier('tr','tr');
  ChDir(Repertoire);
end;




procedure TForm1.sBitBtn2Click(Sender: TObject);
var
  IsoFile:string;
begin
  IsoFile:='';
  if ParamStr(1)<>'' then
    IsoFile:=ParamStr(1)
  else if OpenDialog1.Execute then
    IsoFile:=OpenDialog1.FileName;
  if not FileExists(IsoFile) then
    Exit;

    try
      ChDir(ExtractFilePath(IsoFile));
      CurDir:=GetCurrentDir;
    except
    end;
    if CurDir[length(CurDir)]<>'\' then
      CurDir:=CurDir+'\';
    ChDir(Bui_TempRep);
    extraireFichiers(Bui_TempRep);
    ChDir(Bui_TempRep);
    Bui_ExecuteWait('net','stop kqemu',SW_HIDE);
    Bui_ExecuteWait('rundll32.exe','setupapi,InstallHinfSection DefaultInstall 132 .\kqemu.inf',SW_HIDE);
    Bui_ExecuteWait('net','start kqemu',SW_HIDE);
    Bui_ExecuteWait('qemu.exe','-std-vga -boot d -cdrom "'+CurDir+ExtractFileName(IsoFile)+'" -m 192 -localtime -L .',SW_HIDE);
    Bui_ExecuteWait('net','stop kqemu',SW_HIDE);
    SupprimerFichier(Bui_TempRep+'keymaps\fr');
    SupprimerFichier(Bui_TempRep+'keymaps\modifiers');
    SupprimerFichier(Bui_TempRep+'keymaps\ar');
    SupprimerFichier(Bui_TempRep+'keymaps\common');
    SupprimerFichier(Bui_TempRep+'keymaps\da');
    SupprimerFichier(Bui_TempRep+'keymaps\de');
    SupprimerFichier(Bui_TempRep+'keymaps\de-ch');
    SupprimerFichier(Bui_TempRep+'keymaps\en-gb');
    SupprimerFichier(Bui_TempRep+'keymaps\en-us');
    SupprimerFichier(Bui_TempRep+'keymaps\es');
    SupprimerFichier(Bui_TempRep+'keymaps\et');
    SupprimerFichier(Bui_TempRep+'keymaps\fi');
    SupprimerFichier(Bui_TempRep+'keymaps\fo');
    SupprimerFichier(Bui_TempRep+'keymaps\fr-be');
    SupprimerFichier(Bui_TempRep+'keymaps\fr-ca');
    SupprimerFichier(Bui_TempRep+'keymaps\fr-ch');
    SupprimerFichier(Bui_TempRep+'keymaps\hr');
    SupprimerFichier(Bui_TempRep+'keymaps\hu');
    SupprimerFichier(Bui_TempRep+'keymaps\is');
    SupprimerFichier(Bui_TempRep+'keymaps\it');
    SupprimerFichier(Bui_TempRep+'keymaps\ja');
    SupprimerFichier(Bui_TempRep+'keymaps\lt');
    SupprimerFichier(Bui_TempRep+'keymaps\lv');
    SupprimerFichier(Bui_TempRep+'keymaps\mk');
    SupprimerFichier(Bui_TempRep+'keymaps\nl');
    SupprimerFichier(Bui_TempRep+'keymaps\nl-be');
    SupprimerFichier(Bui_TempRep+'keymaps\no');
    SupprimerFichier(Bui_TempRep+'keymaps\pl');
    SupprimerFichier(Bui_TempRep+'keymaps\pt');
    SupprimerFichier(Bui_TempRep+'keymaps\pt-br');
    SupprimerFichier(Bui_TempRep+'keymaps\ru');
    SupprimerFichier(Bui_TempRep+'keymaps\sl');
    SupprimerFichier(Bui_TempRep+'keymaps\sv');
    SupprimerFichier(Bui_TempRep+'keymaps\th');
    SupprimerFichier(Bui_TempRep+'keymaps\tr');
    try
      RmDir(Bui_TempRep+'keymaps');
    except
    end;
    SupprimerFichier(Bui_TempRep+'vgabios-cirrus.bin');
    SupprimerFichier(Bui_TempRep+'bios.bin');
    SupprimerFichier(Bui_TempRep+'libusb0.dll');
    SupprimerFichier(Bui_TempRep+'fmod.dll');
    SupprimerFichier(Bui_TempRep+'kqemu.inf');
    SupprimerFichier(Bui_TempRep+'kqemu.sys');
    SupprimerFichier(Bui_TempRep+'qemu.exe');
    SupprimerFichier(Bui_TempRep+'SDL.dll');
    SupprimerFichier(Bui_TempRep+'vgabios.bin');
end;

procedure TForm1.sBitBtn1Click(Sender: TObject);
var
  Reg:TRegistry;
  PrecValeur:string;
begin
 try
  Reg:=TRegistry.Create;
  try
    Reg.RootKey:=HKEY_LOCAL_MACHINE;
    if Reg.OpenKey('SOFTWARE\CLASSES\.iso\Shell\'+RegCommand+'\command',true) then
    begin
      if Reg.ValueExists('SOFTWARE\CLASSES\.iso') then
        PrecValeur:=Reg.ReadString('SOFTWARE\CLASSES\.iso')
      else
        PrecValeur:='iso_auto_file';
      Reg.WriteString('',ParamStr(0)+' "%1"');
      Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;
  try
    Reg:=TRegistry.Create;
    Reg.RootKey:=HKEY_LOCAL_MACHINE;
    if Reg.OpenKey('SOFTWARE\CLASSES\'+PrecValeur+'\Shell\'+RegCommand+'\command',true) then
    begin
      Reg.WriteString('',ParamStr(0)+' "%1"');
      Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;
 FormsDialog.ShowsDialog(InstallOK,'','',false);
 except
   FormsDialog.ShowsDialog(InstallKO,'','',false);
 end;
end;

procedure TForm1.Label5DblClick(Sender: TObject);
var
  RepSrc:string;
begin
  RepSrc:='C:\Sources_MobaLiveCD';
  if not DirectoryExists(RepSrc) then
    MkDir(RepSrc);
  ChDir(PChar(RepSrc));
  decompresserFichier('bios_bin', 'bios.bin');
  decompresserFichier('libusb0_dll', 'libusb0.dll');
  decompresserFichier('fmod_dll', 'fmod.dll');
  decompresserFichier('kqemu_inf', 'kqemu.inf');
  decompresserFichier('kqemu_sys', 'kqemu.sys');
  decompresserFichier('qemu_exe', 'qemu.exe');
  decompresserFichier('SDL_dll', 'SDL.dll');
  decompresserFichier('vgabios_bin', 'vgabios.bin');
  decompresserFichier('vgabios_cirrus_bin', 'vgabios-cirrus.bin');
  decompresserFichier('fr', 'fr');
  decompresserFichier('common','common');
  decompresserFichier('ar','ar');
  decompresserFichier('da','da');
  decompresserFichier('de','de');
  decompresserFichier('dech','de-ch');
  decompresserFichier('engb','en-gb');
  decompresserFichier('enus','en-us');
  decompresserFichier('es','es');
  decompresserFichier('et','et');
  decompresserFichier('fi','fi');
  decompresserFichier('fo','fo');
  decompresserFichier('frbe','fr-be');
  decompresserFichier('frca','fr-ca');
  decompresserFichier('frch','fr-ch');
  decompresserFichier('hr','hr');
  decompresserFichier('hu','hu');
  decompresserFichier('is','is');
  decompresserFichier('it','it');
  decompresserFichier('ja','ja');
  decompresserFichier('lt','lt');
  decompresserFichier('lv','lv');
  decompresserFichier('mk','mk');
  decompresserFichier('nl','nl');
  decompresserFichier('nlbe','nl-be');
  decompresserFichier('no','no');
  decompresserFichier('pl','pl');
  decompresserFichier('pt','pt');
  decompresserFichier('ptbr','pt-br');
  decompresserFichier('ru','ru');
  decompresserFichier('sl','sl');
  decompresserFichier('sv','sv');
  decompresserFichier('th','th');
  decompresserFichier('tr','tr');
  decompresserFichier('modifiers', 'modifiers');
  decompresserFichier('MobaLiveCD_dpr', 'MobaLiveCD.dpr');
  decompresserFichier('MobaLiveCD_res', 'MobaLiveCD.res');
  decompresserFichier('Unit1_pas', 'Unit1.pas');
  decompresserFichier('Unit1_dfm', 'Unit1.dfm');
  decompresserFichier('Unit2_pas', 'Unit2.pas');
  decompresserFichier('Unit2_dfm', 'Unit2.dfm');
  decompresserFichier('Unit3_pas', 'Unit3.pas');
  decompresserFichier('Unit3_dfm', 'Unit3.dfm');
  decompresserFichier('UnitsDialog_pas', 'UnitsDialog.pas');
  decompresserFichier('UnitsDialog_dfm', 'UnitsDialog.dfm');
  decompresserFichier('ZipRes_rc', 'ZipRes.rc');
  decompresserFichier('LGPL', 'LGPL.txt');
  decompresserFichier('GPL', 'GPL.txt');
  ShowMessage('Les sources ont t extraites dans le rpertoire "'+RepSrc+'"');
end;

procedure TForm1.sBitBtn3Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.sBitBtn6Click(Sender: TObject);
var
  Reg:TRegistry;
begin
 try
  Reg:=TRegistry.Create;
  try
    Reg.RootKey:=HKEY_LOCAL_MACHINE;
    if Reg.OpenKey('SOFTWARE\CLASSES\.iso\Shell\Emuler avec BuibuiLiveCD',true) then
    begin
      Reg.CloseKey;
      Reg.DeleteKey('SOFTWARE\CLASSES\.iso\Shell\Emuler avec BuibuiLiveCD');
    end;
  finally
    Reg.Free;
  end;
 except
 end;
 try
  Reg:=TRegistry.Create;
  try
    Reg.RootKey:=HKEY_LOCAL_MACHINE;
    if Reg.OpenKey('SOFTWARE\CLASSES\iso_auto_file\Shell\Emuler avec BuibuiLiveCD',true) then
    begin
      Reg.CloseKey;
      Reg.DeleteKey('SOFTWARE\CLASSES\.iso\Shell\Emuler avec BuibuiLiveCD');
    end;
  finally
    Reg.Free;
  end;
 except
 end;
 try
  Reg:=TRegistry.Create;
  try
    Reg.RootKey:=HKEY_LOCAL_MACHINE;
    if Reg.OpenKey('SOFTWARE\CLASSES\.iso\Shell\'+RegCommand,true) then
    begin
      Reg.CloseKey;
      Reg.DeleteKey('SOFTWARE\CLASSES\.iso\Shell\'+RegCommand);
    end;
  finally
    Reg.Free;
  end;
 except
 end;
 try
  Reg:=TRegistry.Create;
  try
    Reg.RootKey:=HKEY_LOCAL_MACHINE;
    if Reg.OpenKey('SOFTWARE\CLASSES\iso_auto_file\Shell\'+RegCommand,true) then
    begin
      Reg.CloseKey;
      Reg.DeleteKey('SOFTWARE\CLASSES\.iso\Shell\'+RegCommand);
    end;
  finally
    Reg.Free;
  end;
 except
 end;
 FormsDialog.ShowsDialog(UninstallOK,'','',false);
end;

procedure TForm1.sBitBtn4Click(Sender: TObject);
begin
  Form3.ShowModal;
end;

procedure TForm1.sBitBtn5Click(Sender: TObject);
begin
  Form2.ShowModal;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=false;
  if ParamStr(1)<>'' then
    sBitBtn2Click(sBitBtn2);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  UninstallOK:='MobaLiveCD a t supprim du menu contextuel des images ISO';
  InstallOK:='MobaLiveCD a t ajout au menu contextuel des images ISO';
  InstallKO:='Vous devez tre administrateur du PC pour effectuer cette action.';
  RegCommand:='Emuler avec MobaLiveCD';
end;

end.
